#include <vector>
#include <stdio.h>

//#include <windows.h>		// Header File For Windows
#include <afxwin.h>
#include <afxext.h>

#include <stdio.h>			// Header File For Standard Input/Output
#include <iostream>
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glut.h>		// Header File For The GLu32 Library
#include <math.h>

#include <mk\mkOpenGLJPEGImage.h> // for loading jpeg textures


#include <string>
#include <sstream>

#define HEIGHT 15
#define WIDTH 15
#define DIM 5
#define DATAFILE "data.dat"
#define IMAGEFILE "images.dat"

using namespace std;

char * mapdir = "c:\\maps\\test.map";
float points[HEIGHT+1][WIDTH+1][3];
GLfloat	xrot;				
GLfloat	yrot;				
GLfloat	zrot;		
GLfloat zoom;
GLuint	texture[227];			// Storage For Lots of Textures (still used in static mode)
int nothing[2];
int dims[2];
int dimension;
string datafile = DATAFILE;

int rlenTotal = 0;
int vsomStep = 0;
//int radius = 12;
//int rlen = 100;
//float alpha = 0.02;
int radius = 10;
string rlen = "10";
int rlenMax = 1000;
string alpha = "0.05";
string dataset = "vsom";

bool run = false;
bool step = false;
bool initialized = false;
bool rough = true;
bool dimSet = false;

class Image {
public:
   char imagePath[256];		// path to image
   int coords[2];			// map coordinates
   float weights[DIM];		// values of weight vector
   float value;
   GLuint texture;
};

class Texture {
public:
	char imagePath[256];
	GLuint texture;
};

// Global data list: current image layout
vector<Image> imageList;
vector<Texture> textureList;

void readMap(const char * fileToRead) {
   FILE * mapFile;
   int dimensions;
   char topology[5] = "rect";
   char imagePath[256];
   int rows;
   int cols;
   char neighbors[8];

   // open map file
   mapFile = fopen(fileToRead, "r");

   fscanf(mapFile, "%d", &dimensions);
   fscanf(mapFile, "%s", topology);
   fscanf(mapFile, "%d", &rows);
   fscanf(mapFile, "%d", &cols);
   fscanf(mapFile, "%s", neighbors);
	
   if(!dimSet) {
	dims[0] = rows;
	dims[1] = cols;
	dimension = dimensions;
	dimSet = true;
   }

   //printf("%d %s %d %d %s\n", dimensions, topology, rows, cols, neighbors);
   
   // reset textures and values for each image
   for(vector<Image>::iterator it = imageList.begin(); it != imageList.end(); ++it) {
			it->value = 0;
			it->texture = NULL;
	}
   for (int i = 0; i < 225; i++) {
		texture[i] = 0;
   }

   float weight;
   int count = 0;
   while (!feof(mapFile)) {
	   for (int n = 0; n<256; n++) {
		   imagePath[n] = 0;
	   }

	   imageList[count].coords[0] = count / rows;
	   imageList[count].coords[1] = count % rows;


	   for (int i =0; i < dimensions; i++) {
			fscanf(mapFile, "%f", &weight);
			imageList[count].weights[i] = weight;
			//printf("%f ", weight);
	   }


	   char nextChar;
	   fscanf(mapFile, "%*c", &nextChar);
       fscanf(mapFile, "%c", &nextChar);
	   //printf("%d\n", nextChar);	


	   if (nextChar == 47) {
		    char temp[256];
			fscanf(mapFile, "%s", temp);
			for(int i = 0; i<249; i++) {
				imagePath[i+7] = temp[i];
			}
			imagePath[0] = '.';
			imagePath[1] = '/';
			imagePath[2] = 'D';
			imagePath[3] = 'a';
			imagePath[4] = 't';
			imagePath[5] = 'a';
			imagePath[6] = nextChar;
			//printf("%s\n", imagePath);
	   }
	   for(int i = 0; i<256; i++) {
			imageList[count].imagePath[i] = imagePath[i];
	   }
	   
	   
	   for(vector<Texture>::iterator it = textureList.begin(); it != textureList.end(); it++) {
			Texture currentTexture = *it;
		   //printf("%d\r", currentTexture.texture);	
		   int status = TRUE;
			for(int i = 7; i<25; i++) {
				if (currentTexture.imagePath[i] != imageList[count].imagePath[i]) {
					status = FALSE;
				}
			}
			if (status) {
				//printf("Tex: %d\n", currentTexture.texture);
				//printf("%s\n", imageList[count].imagePath);
				imageList[count].texture = currentTexture.texture;
				texture[count] = currentTexture.texture;
				break;
			}
	   }
	   if(dims[0] != 15 || dims[1] != 15) printf("\n\ncount = %d\n\n", count);

	  /*for (int i = 0; i<dimension; i++) {
		printf("%f ", theImage->weights[i]);
	  }
	  printf("%s\n\n", theImage->imagePath);*/

	  count++;
	  if(count>226)
	  printf("%d\n", count);
   }

}

string intToString(int i)	// utility function for converting an int to a string
{
	stringstream s;
	s << i;
	return s.str();
}

int LoadJPEGTexture(char *filename , GLuint *texname)
{
	// Declare an mkOpenGLJPEGImage object.
	//printf("Creating new object");
	mkOpenGLJPEGImage jpg;
	//printf("\rNew object created\n");

	// Use verbose error message reporting via message boxes.
	// Not necessary, but can be helpful.
	//printf("Setting debug mode");
	jpg.SetDebugMode(true);
	//printf("\rDebug mode set\n");

	// Load the JPEG file into memory.
	//printf("Loading jpeg from file");
	jpg.LoadFromFile(filename);
	//printf("\rJpeg loaded from file\n");

	// Bind this image to a high performance OpenGL texture object.
	// Store the texture name in the global variable texname1 for
	// later use.  Necessary for using more than one texture at a time.
	//printf("Binding texture");
	*texname = jpg.BindAsTexture();
	//printf("\rTexture successfully bound\n");

	return 1;
}


int LoadGLTextures()									// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator

	int sz = imageList.size()-1;
	printf("%d\n\n", sz);
	for(int i = 0; i < imageList.size()-1; i++) { //imageList.size()
		// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
		Image * currentImage = &imageList[i];
		if(currentImage->imagePath[0] == '.' ) {
			if (LoadJPEGTexture( currentImage->imagePath , &texture[i] ))
			{
				printf("\r%d of %d textures loaded", i, sz);
				Status=TRUE;									// Set The Status To TRUE
			}
		}
	}
	printf("\n");

	return Status;										// Return The Status
}

int LoadAllTextures()				// Load Images And Convert To Textures
{
	int Status=FALSE;				// Status Indicator
	int count = 0;		
	int sz = 225;								

	FILE * texFile;					// Data file with image paths for all images
	
	//char *imagePath[256];

   // open image path file
   texFile = fopen(IMAGEFILE, "r");
   
   // for entire file
   while (!feof(texFile)) {
	   Texture * tex = new Texture;	// New texture object
		// clear image path array
	   for (int n = 0; n<256; n++) {
		   tex->imagePath[n] = 0;
	   }
	   // scan line for image path, save to texture object
		fscanf(texFile, "%s", tex->imagePath);
		//printf("%s\n", tex->imagePath);
   
		// load texture from jpeg
		if ( LoadJPEGTexture( tex->imagePath , &(tex->texture) ) ) {
			printf("\r%d of %d textures loaded: %d", count, sz, tex->texture);	// Display progress
			Status=TRUE;										// Set The Status To TRUE
		}
		
		// add current texture to texture vector
		textureList.push_back(*tex);
		
		count++;
	}
	printf("\n");

	return Status;										// Return The Status
}

// initialize SOM using randinit
string mapinit(string filename) {
	FILE *File=NULL;
	// create command line argument to run randinit
	string init = "c:\\maps\\som\\randinit -xdim 15 -ydim 15 -din " + filename + " -cout init.map -topol rect -neigh bubble -rand 984";
	// execute command line argument for randinit
	WinExec(init.c_str(),SW_SHOWMINNOACTIVE);
	
	// Loop until output file is created
	File=fopen("init.map","r");
	while(!File) { 
		Sleep(5);
		File=fopen("init.map","r");
	}
	fclose(File); // close output file...we were just checking for its presence

	return "init.map"; // return filename of output file
}

void mapinit(string din, string cout) {
	FILE *File=NULL;
	// create command line argument to run randinit
	string init = "c:\\maps\\som\\randinit -xdim 15 -ydim 15 -din " + din + " -cout " + cout + " -topol rect -neigh bubble -rand 984";
	// execute command line argument for randinit
	WinExec(init.c_str(),SW_SHOWMINNOACTIVE);
	
	// Loop until output file is created
	File=fopen(cout.c_str(),"r");
	while(!File) { 
		Sleep(5);
		File=fopen(cout.c_str(),"r");
	}
	fclose(File); // close output file...we were just checking for its presence
}

// run vsom
void vsom(string din, string cin, string cout, string len, string a, string rad) {
	FILE *File=NULL;
	// command line argument for running vsom with specified parameters
	string vsom = "c:\\maps\\som\\vsom -xdim 15 -ydim 15 -din " + din + " -cin " + cin + " -cout " + cout + " -rlen " + len + " -alpha " + a + " -radius " + rad;
    //	printf("%s\n", cout );
	// execute command line argument
	WinExec(vsom.c_str(),SW_SHOWMINNOACTIVE);
	
	// loop until output file exists
	const char *fname = cout.c_str();
	Sleep(5);
	File=fopen(fname,"r");		
	while(!File) {
		Sleep(5);
		File=fopen(fname,"r");
	}
	fclose(File); // close output file
	
	// return nothing because the output file was specified as an argument
}

// add labels to a map using vcal
string vcal(string din, string cin) {
	FILE *File=NULL;
	// command line argument for running vcal on the specified map
	string vcal = "c:\\maps\\som\\vcal -din " + din + " -cin " + cin + " -cout results.map";
	// execute vcal command
	WinExec(vcal.c_str(),SW_SHOWMINNOACTIVE);
	
	// loop until output file exists
	File=fopen("results.map","r");		
	while(!File) {
		Sleep(5);
		File=fopen("results.map","r");
	}
	fclose(File); // close output file

	return "results.map"; // return filename of output file
}

void vcal(string din, string cin, string cout) {
	FILE *File=NULL;
	// command line argument for running vcal on the specified map
	string vcal = "c:\\maps\\som\\vcal -din " + din + " -cin " + cin + " -cout " + cout;
	// execute vcal command
	WinExec(vcal.c_str(),SW_SHOWMINNOACTIVE);
	
	// loop until output file exists
	File=fopen(cout.c_str(),"r");		
	while(!File) {
		Sleep(5);
		File=fopen(cout.c_str(),"r");
	}
	fclose(File); // close output file

}

void initImageList() {
	for (int i = 0; i < (HEIGHT*WIDTH); i++) {
		Image * theImage = new Image;
		imageList.push_back(*theImage);
	}
}

void initGL()										// Setup for openGL
{
	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
	glPolygonMode( GL_BACK, GL_FILL );					// Back Face Is Solid
	glPolygonMode( GL_FRONT, GL_LINE );					// Front Face Is Made Of Lines


	double dx,dy,dz1,dz2,dz;
	int bx,by,bz;
	int rows = dims[1];
	int cols = dims[0];
	printf("%d,%d\n", dims[0], dims[1]);
	// create the initial "landscape", with all heights set to zero
	for(int y=0; y < dims[1]+1; y++) {
		for(int x=0; x < dims[0]+1; x++) {
			points[x][y][0]=float((x)-7.5f);
			points[x][y][1]=float((y)-7.5f);
			points[x][y][2]=0;
		}
	}
	////calculate landscape heights based on SOM weight vectors
	//for(int y=0; y < dims[1]; y++) {
	//	for(int x=0; x < dims[0]; x++) {
	//		// initialize variables
	//		// these keep track of change in value from rect to rect
 //   		dx=0;dy=0;dz1=0;dz2=0;dz=0;
	//		// these are like booleans for change
	//    	bx=0;by=0;bz=0;

	//		int im = x+y*cols;

	//    	for (int k=0;k<dimension;k++) { // dim is dimension of the data
	//	
	//					
	//			int temp;
	//
	//			if (x<(rows-1)) { // map x-dimension
	//	    		temp = (imageList[im].weights[k] - imageList[im+1].weights[k]);
	//	    		dx += temp*temp;
	//	   			bx=1;
	//	  		}
	//			

	//			if (y<(cols-1)){ // map y-dimension
	//    			temp = (imageList[im].weights[k] - imageList[im+rows].weights[k]);
	//    			dy += temp*temp;
	//    			by=1;
	//  			}
	//	
	//			if (y<(cols-1) && x<(rows-1)) {
	//    			temp = (imageList[im].weights[k] - imageList[im+rows+1].weights[k]);
	//    			dz1 += temp*temp;
	//    			temp = (imageList[im+rows].weights[k] - imageList[im+1].weights[k]);
	//    			dz2 += temp*temp;
	//    			bz=1;
	//  			}
	//      	}
	//    	dz = (sqrt(dz1)/sqrt((double) 2.0)+sqrt(dz2)/sqrt((double) 2.0))/2;
	//    
	//		if (bx) {
	//      		imageList[im+1].value = sqrt(dx)/150 - 1.0;
	//		}
	//		if (by) {
	//      		imageList[im+rows].value = sqrt(dy)/150 - 1.0;
	//		}
	//		if (bz) {
	//      		imageList[im+rows+1].value = dz/150 - 1.0;
	//		}
	//	}
	//}

	/*points[15][15][0]=float((15)-7.5f);
	points[15][15][1]=float((15)-7.5f);
	points[15][15][2]=0;*/

	xrot = 0.0f;
	yrot = 0.0f;
	zrot = 0.0f;
	zoom = -15.0f;
}

void render() 
{
	float float_x, float_y, float_xb, float_yb;
	int img = 0;
	int offset = imageList.size()-1-dims[0];

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();									

	glTranslatef(0.0f,0.0f,zoom);
	  
	glRotatef(xrot,1.0f,0.0f,0.0f);
	glRotatef(yrot,0.0f,1.0f,0.0f);  
	glRotatef(zrot,0.0f,0.0f,1.0f);

	for(int y = 0; y < dims[0]; y++ )
	{
		for(int x = 0; x < dims[1]; x++ )
		{
			glBindTexture(GL_TEXTURE_2D, texture[offset+x]);

			glBegin(GL_QUADS);
			glLoadName( img );
			//glDisable( GL_LIGHTING );
			
				
			glColor3f(0, 0.0, 1.0); // blue square
				

			float_x = float(x);//14.0f;
			float_y = float(y);//14.0f;
			float_xb = float(x+1);//14.0f;
			float_yb = float(y+1);//14.0f;

			float val = imageList[img].value;

			glTexCoord2f( float_x, float_y);
			glVertex3f( points[x][y][0], points[x][y][1], val );

			glTexCoord2f( float_x, float_yb );
			glVertex3f( points[x][y+1][0], points[x][y+1][1], val );

			glTexCoord2f( float_xb, float_yb );
			glVertex3f( points[x+1][y+1][0], points[x+1][y+1][1], val );

			glTexCoord2f( float_xb, float_y );
			glVertex3f( points[x+1][y][0], points[x+1][y][1], val );

			glEnd();
			img++;
		}
		offset -= dims[0];
	}
	
}

void renderAnimated() 
{
	float float_x, float_y, float_xb, float_yb;				// 4 coordinates of the texture
	int img = 0;											// counter for which image we're on
	int rows = dims[0];				
	int cols = dims[1];
	
	double dx,dy,dz1,dz2,dz;								// these keep track of change in value from rect to rect
	int bx,by,bz;											// these are like booleans for change

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();									

	glTranslatef(0.0f,0.0f,zoom);							// apply zoom
	  
	glRotatef(xrot,1.0f,0.0f,0.0f);							// apply rotations
	glRotatef(yrot,0.0f,1.0f,0.0f);  
	glRotatef(zrot,0.0f,0.0f,1.0f);

	// calculate "landscape" (heights of each image)
	run;
	for(int y=0; y < dims[1]; y++) {
		for(int x=0; x < dims[0]; x++) {
			// initialize variables
    		dx=0;dy=0;dz1=0;dz2=0;dz=0;
	    	bx=0;by=0;bz=0;

			int im = x+y*cols;	// the current image

			// for each value in weight vector, calculate difference from neighbors
	    	for (int k=0;k<dimension;k++) { 
		
						
				int temp;
	
				if (x<(rows-1)) { // neighbor to right
		    		temp = (imageList[im].weights[k] - imageList[im+1].weights[k]); // calculate difference
		    		dx += temp*temp; // add square of difference to total
		   			bx=1; // set change to true
		  		}
				

				if (y<(cols-1)){ // neighbor below
	    			temp = (imageList[im].weights[k] - imageList[im+rows].weights[k]);	// calculate difference
	    			dy += temp*temp;	// add square of difference to total
	    			by=1;	// set change to true
	  			}
		
				if (y<(cols-1) && x<(rows-1)) { // neighbor diagonal
	    			temp = (imageList[im].weights[k] - imageList[im+rows+1].weights[k]);	// calculate difference
	    			dz1 += temp*temp;	// add square of difference to total
	    			temp = (imageList[im+rows].weights[k] - imageList[im+1].weights[k]);	// calculate difference
	    			dz2 += temp*temp;	// add square of difference to total
	    			bz=1;	// set change to true
	  			}
	      	}
	    	dz = (sqrt(dz1)/sqrt((double) 2.0)+sqrt(dz2)/sqrt((double) 2.0))/2;
	    
			// note: this doesn't seem quite right.  looks like changes in z will be trumped by changes in x and y
			// and changes in y might be trumped by changes in x
		
			if (bx) { // if change
	      		imageList[im+1].value = sqrt(dx)/150 - 1.0; // set neigbor height
			}
			if (by) { // if change
	      		imageList[im+rows].value = sqrt(dy)/150 - 1.0; // set neigbor height
			}
			if (bz) { // if change
	      		imageList[im+rows+1].value = dz/150 - 1.0; // set neigbor height
			}
			if(dims[0] != 15 || dims[1] != 15) printf("\n\nfirst: (x,y) = (%d, %d)\n\n", x, y);
		}
	}

	
	// draw the damn thing
	for(int y = 0; y < dims[0]; y++ )
	{
		for(int x = 0; x < dims[1]; x++ )
		{
			
			// use this texture
			//printf("%d\n", imageList[img].texture);
			//printf("%s\n", imageList[img].imagePath);
			/*if (img < 15) {
			printf("%d\n", textureList[img].texture);
			glBindTexture(GL_TEXTURE_2D, (GLuint)img);
			}*/
			/*int im = y*dims[0] + x;
			glBindTexture(GL_TEXTURE_2D, textureList[im].texture);*/
			run;
			dims[0];
			y;
			glBindTexture(GL_TEXTURE_2D, (GLuint)(img+1));//imageList[img].texture);

			glBegin(GL_QUADS);
			glLoadName( img );
			//glDisable( GL_LIGHTING );
			
			
			glColor3f(0, 0.0, 1.0); // blue square
				
			dims[0];
			// set texture coordinates
			float_x = float(x);
			float_y = float(y);
			float_xb = float(x+1);
			float_yb = float(y+1);
			// get height value for current image
			float val = imageList[img].value;

			glTexCoord2f( float_x, float_y);
			glVertex3f( points[x][y][0], points[x][y][1], val );

			glTexCoord2f( float_x, float_yb );
			glVertex3f( points[x][y+1][0], points[x][y+1][1], val );

			glTexCoord2f( float_xb, float_yb );
			glVertex3f( points[x+1][y+1][0], points[x+1][y+1][1], val );

			glTexCoord2f( float_xb, float_y );
			glVertex3f( points[x+1][y][0], points[x+1][y][1], val );

			glEnd();
			img++; // next image
			if(dims[0] != 15 || dims[1] != 15) printf("\n\n(x,y) = (%d, %d)\n\n", x, y);
		}
	}
	
}

void initializeSOM() {
	if (!initialized) {
		// initialize the SOM
		mapinit(datafile,"vsom0.map");
		vcal(datafile,"vsom0.map","results.map");
		// read initial map
		readMap( "results.map" );
		initialized = true;

		renderAnimated();
		glutPostRedisplay();
	}
}

void toggleRun() {
	if(run) run = false;
	else run = true;
}

void changeSOMGrain() {
	alpha = "0.02";
	radius = 2;
	rough = false;
}

void loadNewData(string data) {
	run = false;
	//WinExec("rm *.map",SW_SHOWMINNOACTIVE);
	
	datafile = data + ".dat";
	dataset = data;
	vsomStep = 0;
	rlenTotal = 0;
	radius = 10;
	alpha = "0.02";

	mapinit(datafile,data+"0.map");
	vcal(datafile,data+"0.map","results.map");
	Sleep(10);
	// read initial map
	readMap( "results.map" );
	initialized = true;
	dimSet = false;
	
}

void keyboard( int key, int x, int y ) 
{
	switch (key) {
			// for camera rotation
			case GLUT_KEY_LEFT : yrot+=1;break;
			case GLUT_KEY_RIGHT : yrot-=1;break;
			case GLUT_KEY_UP : xrot+=1;break;
			case GLUT_KEY_DOWN : xrot-=1;break;
			// for zoom
			case GLUT_KEY_PAGE_UP : zoom--;break;
			case GLUT_KEY_PAGE_DOWN : zoom++;break;
			//case GLUT_KEY_HOME : mode = true;break;
			//case GLUT_KEY_END : mode = false;break;
	}

}

void keys( unsigned char key, int x, int y ) 
{
	switch (key) {
			case 'r' : toggleRun();break;
			case 's' : step=true;break;
			case 'i' : initializeSOM();break;
			case 'm' : changeSOMGrain();break;
			case 'z' : printf("%f\n", zoom);break;

			case '1' : loadNewData("aperture");
			case '2' : loadNewData("f_stop");
			case '3' : loadNewData("flash");
			case '4' : loadNewData("focal_length");
			case '5' : loadNewData("shutter_speed");
			case '0' : loadNewData("data");
	}

}

void redisplay()
{
	render();
	glutPostRedisplay();
}

void idleStatic() 
{
	Sleep(100);
}

void idleAnimated() 
{
	if ( (rlenTotal > rlenMax) && rough ) {
	}
	if ( (rlenTotal < 11001) && (step || run) ) {
		// create strings holding input and output file names
		// note that we need to keep creating new files to ensure that the program waits for the file to be created before continuing
		string vsomIn = dataset + intToString(vsomStep) + ".map";
		string vsomOut = dataset + intToString(++vsomStep) + ".map";
		string results = dataset + intToString(vsomStep) + ".map";
		// run 100 iterations of vsom at radius 12, alpha 0.02
		vsom(datafile,vsomIn,vsomOut,rlen,alpha,intToString(radius));
		// add labels to SOM
		vcal(datafile,vsomOut, results);
		// read in the results for display
		readMap( results.c_str() );

		if (step) step = false;
		rlenTotal += 10;
	}

	// re-render to show changes
	renderAnimated();
	glutPostRedisplay();
	// sleep for half a second so that the changes don't happen too often
	Sleep(50);
	
}

void display() 
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	render();

	glutSwapBuffers();
}

void reshape( int w, int h ) 
{

	glViewport( 0, 0, (GLsizei) w, (GLsizei) h );
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	gluPerspective( 60.0, (GLdouble) w/(GLdouble) h, 1.0, 100.0 );
	glMatrixMode( GL_MODELVIEW );

	glEnable( GL_LIGHTING );
	glEnable( GL_LIGHT0 );
	glRenderMode( GL_FLAT );
}

void runStatic() {

	initImageList();

	readMap(mapdir);
	
	if( !LoadGLTextures() ) {
		printf("Texture did not load properly");
	}

	initGL();

	glutIdleFunc( idleStatic );
	glutDisplayFunc( display );
	glutReshapeFunc( reshape );

	glutSpecialFunc( keyboard );

	glutMainLoop();
	
}


void runAnimated() {

	initImageList();

	// load all available textures at the beginning, so we don't have to do it later
	// note: this is time intensive
	if( !LoadAllTextures() ) {
		printf("Texture did not load properly");
	}
	
	// initialize the SOM
	mapinit(datafile,"vsom0.map");
	vcal(datafile,"vsom0.map","results.map");
	// read initial map
	readMap( "results.map" );
	initialized = true;

	// initialize openGL
	initGL();
	// register basic glut methods
	glutIdleFunc( idleAnimated );
	glutDisplayFunc( display );
	glutReshapeFunc( reshape );
	// register special glut methods
	glutSpecialFunc( keyboard );
	glutKeyboardFunc( keys );

		//// create strings holding input and output file names
		//// note that we need to keep creating new files to ensure that the program waits for the file to be created before continuing
		//string vsomIn = "init.map";
		//string vsomOut = "vsom0.map";
		//// run 100 iterations of vsom at radius 12, alpha 0.02
		//vsom(DATAFILE,vsomIn,vsomOut,"1","0.02","12");
		//// add labels to SOM
		//string displayMap = vcal(DATAFILE,vsomOut);
		//// read in the results for display
		//readMap( displayMap.c_str() );
		//// re-render to show changes
		renderAnimated();
		glutPostRedisplay();

	glutMainLoop();

	
}


int main( int argc, char **argv ) 
{
	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH );
	glutInitWindowSize( 960, 720 );
	glutInitWindowPosition( 10, 10 );
	glutCreateWindow( argv[0] );

	runAnimated();	

	return 0;

}